local calc = require("#Monocle.Calc")
local monocle = require("#Monocle")
local colors = require("#Microsoft.Xna.Framework.Color")

local playerInside = false

local function glitch(glitch, anxiety, duration)
    celeste.Audio.Play("event:/new_content/game/10_farewell/glitch_short", player.Position)
    celeste.Glitch.Value = glitch
    celeste.Distort.Anxiety = anxiety
    wait(duration)
end

local function particleAbsorbBurst(n)
    for i = 1, n do
        engine.Scene:Add(celeste.AbsorbOrb(player.Position))
    end
end

function onBegin()
    makeUnskippable()
    disableRetry()
    disableMovement()
    say("DIALOG_END_MOONBERRY")
        
    glitch(0.7, 3, 0)

    if not player.Dead then
        monocle.engine.TimeRate = 1
        celeste.Glitch.Value = 0
        celeste.Distort.Anxiety = 0
        engine.Scene.FormationBackdrop.Display = false
        engine.Scene.FormationBackdrop.Alpha = 0
		enableMovement()
        teleportTo(7108, 210, "b03")
    end
end

function onEnter()
    playerInside = true
end

function onLeave()
    playerInside = false
end

function onEnd()
	enableMovement()
end